/**
 */
package tools.descartes.dni.dnimm3ap;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import tools.descartes.dni.dnimm3.DNIPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dni.dnimm3ap.DNIAPFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/GenModel modelDirectory='/tools.descartes.dni.adaptation/src/main/java' editDirectory='/tools.descartes.dni.adaptation/src/main/java' editorDirectory='/tools.descartes.dni.adaptation/src/main/java' fileExtensions='dniap' prefix='DNIAP' basePackage='tools.descartes.dni'"
 * @generated
 */
public interface DNIAPPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "dnimm3ap";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dni-adaptation-metamodel-3.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "dnimm3ap";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DNIAPPackage eINSTANCE = tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl <em>Adaptation Points</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationPoints()
	 * @generated
	 */
	int ADAPTATION_POINTS = 0;

	/**
	 * The feature id for the '<em><b>Repositories</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS__REPOSITORIES = 0;

	/**
	 * The feature id for the '<em><b>Groups</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS__GROUPS = 1;

	/**
	 * The number of structural features of the '<em>Adaptation Points</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Adaptation Points</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl <em>Adaptation Repositories</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationRepositories()
	 * @generated
	 */
	int ADAPTATION_REPOSITORIES = 1;

	/**
	 * The feature id for the '<em><b>Node Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__NODE_REPOSITORY = 0;

	/**
	 * The feature id for the '<em><b>End Performance Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY = 1;

	/**
	 * The feature id for the '<em><b>Intermediate Performance Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY = 2;

	/**
	 * The feature id for the '<em><b>Sdn Node Performance Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY = 3;

	/**
	 * The feature id for the '<em><b>Network Interface Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY = 4;

	/**
	 * The feature id for the '<em><b>Network Interface Performance Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY = 5;

	/**
	 * The feature id for the '<em><b>Link Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__LINK_REPOSITORY = 6;

	/**
	 * The feature id for the '<em><b>Link Performance Repository</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY = 7;

	/**
	 * The number of structural features of the '<em>Adaptation Repositories</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES_FEATURE_COUNT = 8;

	/**
	 * The number of operations of the '<em>Adaptation Repositories</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORIES_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository <em>IAdaptable Entity Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntityRepository()
	 * @generated
	 */
	int IADAPTABLE_ENTITY_REPOSITORY = 2;

	/**
	 * The number of structural features of the '<em>IAdaptable Entity Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>IAdaptable Entity Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeRepositoryImpl <em>Adaptable Node Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNodeRepository()
	 * @generated
	 */
	int ADAPTABLE_NODE_REPOSITORY = 3;

	/**
	 * The feature id for the '<em><b>Node</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_REPOSITORY__NODE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Node Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Node Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkRepositoryImpl <em>Adaptable Link Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkRepository()
	 * @generated
	 */
	int ADAPTABLE_LINK_REPOSITORY = 4;

	/**
	 * The feature id for the '<em><b>Link</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_REPOSITORY__LINK = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Link Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Link Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceRepositoryImpl <em>Adaptable Link Performance Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformanceRepository()
	 * @generated
	 */
	int ADAPTABLE_LINK_PERFORMANCE_REPOSITORY = 5;

	/**
	 * The feature id for the '<em><b>Link Performance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_REPOSITORY__LINK_PERFORMANCE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Link Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Link Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceRepositoryImpl <em>Adaptable End Performance Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformanceRepository()
	 * @generated
	 */
	int ADAPTABLE_END_PERFORMANCE_REPOSITORY = 6;

	/**
	 * The feature id for the '<em><b>End Performance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_REPOSITORY__END_PERFORMANCE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable End Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable End Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceRepositoryImpl <em>Adaptable Intermediate Performance Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformanceRepository()
	 * @generated
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY = 7;

	/**
	 * The feature id for the '<em><b>Intermediate Performance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY__INTERMEDIATE_PERFORMANCE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Intermediate Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Intermediate Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceRepositoryImpl <em>Adaptable Sdn Node Performance Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformanceRepository()
	 * @generated
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY = 8;

	/**
	 * The feature id for the '<em><b>Sdn Node Performance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY__SDN_NODE_PERFORMANCE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Sdn Node Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Sdn Node Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceRepositoryImpl <em>Adaptable Network Interface Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfaceRepository()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE_REPOSITORY = 9;

	/**
	 * The feature id for the '<em><b>Network Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_REPOSITORY__NETWORK_INTERFACES = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceRepositoryImpl <em>Adaptable Network Interface Performance Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformanceRepository()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY = 10;

	/**
	 * The feature id for the '<em><b>Network Interface Performance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY__NETWORK_INTERFACE_PERFORMANCE = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY_FEATURE_COUNT = IADAPTABLE_ENTITY_REPOSITORY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface Performance Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY_OPERATION_COUNT = IADAPTABLE_ENTITY_REPOSITORY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntity()
	 * @generated
	 */
	int IADAPTABLE_ENTITY = 11;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY__ENTITY_TYPE = 0;

	/**
	 * The number of structural features of the '<em>IAdaptable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>IAdaptable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableGroupableEntity()
	 * @generated
	 */
	int IADAPTABLE_GROUPABLE_ENTITY = 12;

	/**
	 * The number of structural features of the '<em>IAdaptable Groupable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_GROUPABLE_ENTITY_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>IAdaptable Groupable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_GROUPABLE_ENTITY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl <em>Adaptable Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNode()
	 * @generated
	 */
	int ADAPTABLE_NODE = 13;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>End Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__END_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Intermediate Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Sdn Node Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__SDN_NODE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Network Interface</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__NETWORK_INTERFACE = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Adaptation Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__ADAPTATION_GROUP = IADAPTABLE_ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Adaptable Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Adaptable Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl <em>Adaptable Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLink()
	 * @generated
	 */
	int ADAPTABLE_LINK = 14;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Link Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__LINK_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Network Interface</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__NETWORK_INTERFACE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Adaptation Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__ADAPTATION_GROUP = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Adaptable Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Adaptable Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl <em>Adaptable Link Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformance()
	 * @generated
	 */
	int ADAPTABLE_LINK_PERFORMANCE = 15;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__PROPAGATION_DELAY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Maximal Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__MAXIMAL_SUPPORTED_BANDWIDTH = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Link Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Link Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl <em>Adaptable End Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformance()
	 * @generated
	 */
	int ADAPTABLE_END_PERFORMANCE = 16;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software Layers Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Adaptable End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Adaptable End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl <em>Adaptable Intermediate Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformance()
	 * @generated
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE = 17;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Forwarding Latency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Switching Capacity PPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Adaptable Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Adaptable Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl <em>Adaptable Sdn Node Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformance()
	 * @generated
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE = 18;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software Switching Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__SOFTWARE_SWITCHING_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Hardware Switching Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__HARDWARE_SWITCHING_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Sdn Node Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Sdn Node Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl <em>Adaptable Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterface()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE = 19;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Network Interface Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__NETWORK_INTERFACE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl <em>Adaptable Network Interface Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE = 20;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__PACKET_PROCESSING_TIME = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface Throughput</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__INTERFACE_THROUGHPUT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl <em>Adaptation Groups</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationGroups()
	 * @generated
	 */
	int ADAPTATION_GROUPS = 21;

	/**
	 * The feature id for the '<em><b>Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS__GROUPS = 0;

	/**
	 * The number of structural features of the '<em>Adaptation Groups</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Adaptation Groups</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptationGroup()
	 * @generated
	 */
	int IADAPTATION_GROUP = 22;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__NAME = DNIPackage.NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__DESCRIPTION = DNIPackage.NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The number of structural features of the '<em>IAdaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP_FEATURE_COUNT = DNIPackage.NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>IAdaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP_OPERATION_COUNT = DNIPackage.NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl <em>Node Adaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getNodeAdaptationGroup()
	 * @generated
	 */
	int NODE_ADAPTATION_GROUP = 23;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__NAME = IADAPTATION_GROUP__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__DESCRIPTION = IADAPTATION_GROUP__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__ITEMS = IADAPTATION_GROUP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Node Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP_FEATURE_COUNT = IADAPTATION_GROUP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Node Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP_OPERATION_COUNT = IADAPTATION_GROUP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl <em>Link Adaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getLinkAdaptationGroup()
	 * @generated
	 */
	int LINK_ADAPTATION_GROUP = 24;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__NAME = IADAPTATION_GROUP__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__DESCRIPTION = IADAPTATION_GROUP__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__ITEMS = IADAPTATION_GROUP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Link Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP_FEATURE_COUNT = IADAPTATION_GROUP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Link Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP_OPERATION_COUNT = IADAPTATION_GROUP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.AlternativeParameterSet <em>Alternative Parameter Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.AlternativeParameterSet
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeParameterSet()
	 * @generated
	 */
	int ALTERNATIVE_PARAMETER_SET = 25;

	/**
	 * The feature id for the '<em><b>Alternative</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_PARAMETER_SET__ALTERNATIVE = 0;

	/**
	 * The number of structural features of the '<em>Alternative Parameter Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_PARAMETER_SET_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Alternative Parameter Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_PARAMETER_SET_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableImpl <em>Alternative Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariable()
	 * @generated
	 */
	int ALTERNATIVE_VARIABLE = 26;

	/**
	 * The number of structural features of the '<em>Alternative Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Alternative Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl <em>Alternative Variable Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariableSet()
	 * @generated
	 */
	int ALTERNATIVE_VARIABLE_SET = 27;

	/**
	 * The feature id for the '<em><b>Alternative</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET__ALTERNATIVE = ALTERNATIVE_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Alternative Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET_FEATURE_COUNT = ALTERNATIVE_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Alternative Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET_OPERATION_COUNT = ALTERNATIVE_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongImpl <em>Alternative Constant Long</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeConstantLong()
	 * @generated
	 */
	int ALTERNATIVE_CONSTANT_LONG = 28;

	/**
	 * The number of structural features of the '<em>Alternative Constant Long</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_CONSTANT_LONG_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Alternative Constant Long</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_CONSTANT_LONG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongVariableSetImpl <em>Alternative Constant Long Variable Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongVariableSetImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeConstantLongVariableSet()
	 * @generated
	 */
	int ALTERNATIVE_CONSTANT_LONG_VARIABLE_SET = 29;

	/**
	 * The feature id for the '<em><b>Alternative</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_CONSTANT_LONG_VARIABLE_SET__ALTERNATIVE = ALTERNATIVE_CONSTANT_LONG_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Alternative Constant Long Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_CONSTANT_LONG_VARIABLE_SET_FEATURE_COUNT = ALTERNATIVE_CONSTANT_LONG_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Alternative Constant Long Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_CONSTANT_LONG_VARIABLE_SET_OPERATION_COUNT = ALTERNATIVE_CONSTANT_LONG_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints <em>Adaptation Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Points</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints
	 * @generated
	 */
	EClass getAdaptationPoints();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints#getRepositories <em>Repositories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Repositories</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints#getRepositories()
	 * @see #getAdaptationPoints()
	 * @generated
	 */
	EReference getAdaptationPoints_Repositories();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints#getGroups <em>Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Groups</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints#getGroups()
	 * @see #getAdaptationPoints()
	 * @generated
	 */
	EReference getAdaptationPoints_Groups();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories <em>Adaptation Repositories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Repositories</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories
	 * @generated
	 */
	EClass getAdaptationRepositories();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNodeRepository <em>Node Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Node Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNodeRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_NodeRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getEndPerformanceRepository <em>End Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>End Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getEndPerformanceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_EndPerformanceRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getIntermediatePerformanceRepository <em>Intermediate Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intermediate Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getIntermediatePerformanceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_IntermediatePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getSdnNodePerformanceRepository <em>Sdn Node Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sdn Node Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getSdnNodePerformanceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_SdnNodePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNetworkInterfaceRepository <em>Network Interface Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Network Interface Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNetworkInterfaceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_NetworkInterfaceRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNetworkInterfacePerformanceRepository <em>Network Interface Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Network Interface Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getNetworkInterfacePerformanceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_NetworkInterfacePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getLinkRepository <em>Link Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Link Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getLinkRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_LinkRepository();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationRepositories#getLinkPerformanceRepository <em>Link Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Link Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepositories#getLinkPerformanceRepository()
	 * @see #getAdaptationRepositories()
	 * @generated
	 */
	EReference getAdaptationRepositories_LinkPerformanceRepository();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository <em>IAdaptable Entity Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptable Entity Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository
	 * @generated
	 */
	EClass getIAdaptableEntityRepository();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNodeRepository <em>Adaptable Node Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Node Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNodeRepository
	 * @generated
	 */
	EClass getAdaptableNodeRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNodeRepository#getNode <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Node</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNodeRepository#getNode()
	 * @see #getAdaptableNodeRepository()
	 * @generated
	 */
	EReference getAdaptableNodeRepository_Node();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkRepository <em>Adaptable Link Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkRepository
	 * @generated
	 */
	EClass getAdaptableLinkRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkRepository#getLink <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Link</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkRepository#getLink()
	 * @see #getAdaptableLinkRepository()
	 * @generated
	 */
	EReference getAdaptableLinkRepository_Link();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformanceRepository <em>Adaptable Link Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformanceRepository
	 * @generated
	 */
	EClass getAdaptableLinkPerformanceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformanceRepository#getLinkPerformance <em>Link Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Link Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformanceRepository#getLinkPerformance()
	 * @see #getAdaptableLinkPerformanceRepository()
	 * @generated
	 */
	EReference getAdaptableLinkPerformanceRepository_LinkPerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformanceRepository <em>Adaptable End Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable End Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformanceRepository
	 * @generated
	 */
	EClass getAdaptableEndPerformanceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformanceRepository#getEndPerformance <em>End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformanceRepository#getEndPerformance()
	 * @see #getAdaptableEndPerformanceRepository()
	 * @generated
	 */
	EReference getAdaptableEndPerformanceRepository_EndPerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformanceRepository <em>Adaptable Intermediate Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Intermediate Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformanceRepository
	 * @generated
	 */
	EClass getAdaptableIntermediatePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformanceRepository#getIntermediatePerformance <em>Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformanceRepository#getIntermediatePerformance()
	 * @see #getAdaptableIntermediatePerformanceRepository()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformanceRepository_IntermediatePerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformanceRepository <em>Adaptable Sdn Node Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Sdn Node Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformanceRepository
	 * @generated
	 */
	EClass getAdaptableSdnNodePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformanceRepository#getSdnNodePerformance <em>Sdn Node Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sdn Node Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformanceRepository#getSdnNodePerformance()
	 * @see #getAdaptableSdnNodePerformanceRepository()
	 * @generated
	 */
	EReference getAdaptableSdnNodePerformanceRepository_SdnNodePerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfaceRepository <em>Adaptable Network Interface Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfaceRepository
	 * @generated
	 */
	EClass getAdaptableNetworkInterfaceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfaceRepository#getNetworkInterfaces <em>Network Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Network Interfaces</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfaceRepository#getNetworkInterfaces()
	 * @see #getAdaptableNetworkInterfaceRepository()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfaceRepository_NetworkInterfaces();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformanceRepository <em>Adaptable Network Interface Performance Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface Performance Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformanceRepository
	 * @generated
	 */
	EClass getAdaptableNetworkInterfacePerformanceRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformanceRepository#getNetworkInterfacePerformance <em>Network Interface Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Network Interface Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformanceRepository#getNetworkInterfacePerformance()
	 * @see #getAdaptableNetworkInterfacePerformanceRepository()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfacePerformanceRepository_NetworkInterfacePerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptable Entity</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
	 * @generated
	 */
	EClass getIAdaptableEntity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity#getEntityType()
	 * @see #getIAdaptableEntity()
	 * @generated
	 */
	EReference getIAdaptableEntity_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptable Groupable Entity</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
	 * @generated
	 */
	EClass getIAdaptableGroupableEntity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNode <em>Adaptable Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Node</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode
	 * @generated
	 */
	EClass getAdaptableNode();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getName()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EAttribute getAdaptableNode_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getEndPerformance <em>End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getEndPerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_EndPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getIntermediatePerformance <em>Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getIntermediatePerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_IntermediatePerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getSdnNodePerformance <em>Sdn Node Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sdn Node Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getSdnNodePerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_SdnNodePerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getNetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getNetworkInterface()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_NetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getAdaptationGroup <em>Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getAdaptationGroup()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_AdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLink <em>Adaptable Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink
	 * @generated
	 */
	EClass getAdaptableLink();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getName()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EAttribute getAdaptableLink_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getLinkPerformance <em>Link Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Link Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getLinkPerformance()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_LinkPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getNetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getNetworkInterface()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_NetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getAdaptationGroup <em>Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getAdaptationGroup()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_AdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance <em>Adaptable Link Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance
	 * @generated
	 */
	EClass getAdaptableLinkPerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getName()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EAttribute getAdaptableLinkPerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getPropagationDelay <em>Propagation Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Propagation Delay</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getPropagationDelay()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EReference getAdaptableLinkPerformance_PropagationDelay();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getMaximalSupportedBandwidth <em>Maximal Supported Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Maximal Supported Bandwidth</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getMaximalSupportedBandwidth()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EReference getAdaptableLinkPerformance_MaximalSupportedBandwidth();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance <em>Adaptable End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance
	 * @generated
	 */
	EClass getAdaptableEndPerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getName()
	 * @see #getAdaptableEndPerformance()
	 * @generated
	 */
	EAttribute getAdaptableEndPerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getSoftwareLayersDelay <em>Software Layers Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Software Layers Delay</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getSoftwareLayersDelay()
	 * @see #getAdaptableEndPerformance()
	 * @generated
	 */
	EReference getAdaptableEndPerformance_SoftwareLayersDelay();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance <em>Adaptable Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance
	 * @generated
	 */
	EClass getAdaptableIntermediatePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getName()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EAttribute getAdaptableIntermediatePerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingLatency <em>Forwarding Latency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Latency</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingLatency()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_ForwardingLatency();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getSwitchingCapacityPPS <em>Switching Capacity PPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Switching Capacity PPS</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getSwitchingCapacityPPS()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_SwitchingCapacityPPS();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingBandwidthBPS <em>Forwarding Bandwidth BPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Bandwidth BPS</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingBandwidthBPS()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_ForwardingBandwidthBPS();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance <em>Adaptable Sdn Node Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Sdn Node Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance
	 * @generated
	 */
	EClass getAdaptableSdnNodePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getName()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EAttribute getAdaptableSdnNodePerformance_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getSoftwareSwitchingPerformance <em>Software Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Software Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getSoftwareSwitchingPerformance()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EReference getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getHardwareSwitchingPerformance <em>Hardware Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Hardware Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getHardwareSwitchingPerformance()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EReference getAdaptableSdnNodePerformance_HardwareSwitchingPerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface <em>Adaptable Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface
	 * @generated
	 */
	EClass getAdaptableNetworkInterface();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getName()
	 * @see #getAdaptableNetworkInterface()
	 * @generated
	 */
	EAttribute getAdaptableNetworkInterface_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getNetworkInterfacePerformance <em>Network Interface Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getNetworkInterfacePerformance()
	 * @see #getAdaptableNetworkInterface()
	 * @generated
	 */
	EReference getAdaptableNetworkInterface_NetworkInterfacePerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance <em>Adaptable Network Interface Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance
	 * @generated
	 */
	EClass getAdaptableNetworkInterfacePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getName()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EAttribute getAdaptableNetworkInterfacePerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getPacketProcessingTime()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfacePerformance_PacketProcessingTime();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getInterfaceThroughput <em>Interface Throughput</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Throughput</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getInterfaceThroughput()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfacePerformance_InterfaceThroughput();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationGroups <em>Adaptation Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Groups</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationGroups
	 * @generated
	 */
	EClass getAdaptationGroups();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationGroups#getGroups <em>Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Groups</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationGroups#getGroups()
	 * @see #getAdaptationGroups()
	 * @generated
	 */
	EReference getAdaptationGroups_Groups();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
	 * @generated
	 */
	EClass getIAdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup <em>Node Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.NodeAdaptationGroup
	 * @generated
	 */
	EClass getNodeAdaptationGroup();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Items</em>'.
	 * @see tools.descartes.dni.dnimm3ap.NodeAdaptationGroup#getItems()
	 * @see #getNodeAdaptationGroup()
	 * @generated
	 */
	EReference getNodeAdaptationGroup_Items();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup <em>Link Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.LinkAdaptationGroup
	 * @generated
	 */
	EClass getLinkAdaptationGroup();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Items</em>'.
	 * @see tools.descartes.dni.dnimm3ap.LinkAdaptationGroup#getItems()
	 * @see #getLinkAdaptationGroup()
	 * @generated
	 */
	EReference getLinkAdaptationGroup_Items();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeParameterSet <em>Alternative Parameter Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Parameter Set</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeParameterSet
	 * @generated
	 */
	EClass getAlternativeParameterSet();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AlternativeParameterSet#getAlternative <em>Alternative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Alternative</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeParameterSet#getAlternative()
	 * @see #getAlternativeParameterSet()
	 * @generated
	 */
	EReference getAlternativeParameterSet_Alternative();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeVariable <em>Alternative Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Variable</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariable
	 * @generated
	 */
	EClass getAlternativeVariable();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeVariableSet <em>Alternative Variable Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Variable Set</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariableSet
	 * @generated
	 */
	EClass getAlternativeVariableSet();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeConstantLong <em>Alternative Constant Long</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Constant Long</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeConstantLong
	 * @generated
	 */
	EClass getAlternativeConstantLong();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeConstantLongVariableSet <em>Alternative Constant Long Variable Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Constant Long Variable Set</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeConstantLongVariableSet
	 * @generated
	 */
	EClass getAlternativeConstantLongVariableSet();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DNIAPFactory getDNIAPFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl <em>Adaptation Points</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationPoints()
		 * @generated
		 */
		EClass ADAPTATION_POINTS = eINSTANCE.getAdaptationPoints();

		/**
		 * The meta object literal for the '<em><b>Repositories</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_POINTS__REPOSITORIES = eINSTANCE.getAdaptationPoints_Repositories();

		/**
		 * The meta object literal for the '<em><b>Groups</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_POINTS__GROUPS = eINSTANCE.getAdaptationPoints_Groups();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl <em>Adaptation Repositories</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationRepositories()
		 * @generated
		 */
		EClass ADAPTATION_REPOSITORIES = eINSTANCE.getAdaptationRepositories();

		/**
		 * The meta object literal for the '<em><b>Node Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__NODE_REPOSITORY = eINSTANCE.getAdaptationRepositories_NodeRepository();

		/**
		 * The meta object literal for the '<em><b>End Performance Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptationRepositories_EndPerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Intermediate Performance Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptationRepositories_IntermediatePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Sdn Node Performance Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptationRepositories_SdnNodePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Network Interface Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY = eINSTANCE.getAdaptationRepositories_NetworkInterfaceRepository();

		/**
		 * The meta object literal for the '<em><b>Network Interface Performance Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptationRepositories_NetworkInterfacePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Link Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__LINK_REPOSITORY = eINSTANCE.getAdaptationRepositories_LinkRepository();

		/**
		 * The meta object literal for the '<em><b>Link Performance Repository</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptationRepositories_LinkPerformanceRepository();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository <em>IAdaptable Entity Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntityRepository
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntityRepository()
		 * @generated
		 */
		EClass IADAPTABLE_ENTITY_REPOSITORY = eINSTANCE.getIAdaptableEntityRepository();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeRepositoryImpl <em>Adaptable Node Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNodeRepository()
		 * @generated
		 */
		EClass ADAPTABLE_NODE_REPOSITORY = eINSTANCE.getAdaptableNodeRepository();

		/**
		 * The meta object literal for the '<em><b>Node</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE_REPOSITORY__NODE = eINSTANCE.getAdaptableNodeRepository_Node();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkRepositoryImpl <em>Adaptable Link Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkRepository()
		 * @generated
		 */
		EClass ADAPTABLE_LINK_REPOSITORY = eINSTANCE.getAdaptableLinkRepository();

		/**
		 * The meta object literal for the '<em><b>Link</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_REPOSITORY__LINK = eINSTANCE.getAdaptableLinkRepository_Link();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceRepositoryImpl <em>Adaptable Link Performance Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformanceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_LINK_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptableLinkPerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Link Performance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_PERFORMANCE_REPOSITORY__LINK_PERFORMANCE = eINSTANCE.getAdaptableLinkPerformanceRepository_LinkPerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceRepositoryImpl <em>Adaptable End Performance Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformanceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_END_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptableEndPerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>End Performance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_END_PERFORMANCE_REPOSITORY__END_PERFORMANCE = eINSTANCE.getAdaptableEndPerformanceRepository_EndPerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceRepositoryImpl <em>Adaptable Intermediate Performance Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformanceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptableIntermediatePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Intermediate Performance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE_REPOSITORY__INTERMEDIATE_PERFORMANCE = eINSTANCE.getAdaptableIntermediatePerformanceRepository_IntermediatePerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceRepositoryImpl <em>Adaptable Sdn Node Performance Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformanceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptableSdnNodePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Sdn Node Performance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_SDN_NODE_PERFORMANCE_REPOSITORY__SDN_NODE_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformanceRepository_SdnNodePerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceRepositoryImpl <em>Adaptable Network Interface Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfaceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE_REPOSITORY = eINSTANCE.getAdaptableNetworkInterfaceRepository();

		/**
		 * The meta object literal for the '<em><b>Network Interfaces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_REPOSITORY__NETWORK_INTERFACES = eINSTANCE.getAdaptableNetworkInterfaceRepository_NetworkInterfaces();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceRepositoryImpl <em>Adaptable Network Interface Performance Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformanceRepository()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY = eINSTANCE.getAdaptableNetworkInterfacePerformanceRepository();

		/**
		 * The meta object literal for the '<em><b>Network Interface Performance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_REPOSITORY__NETWORK_INTERFACE_PERFORMANCE = eINSTANCE.getAdaptableNetworkInterfacePerformanceRepository_NetworkInterfacePerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntity()
		 * @generated
		 */
		EClass IADAPTABLE_ENTITY = eINSTANCE.getIAdaptableEntity();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IADAPTABLE_ENTITY__ENTITY_TYPE = eINSTANCE.getIAdaptableEntity_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableGroupableEntity()
		 * @generated
		 */
		EClass IADAPTABLE_GROUPABLE_ENTITY = eINSTANCE.getIAdaptableGroupableEntity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl <em>Adaptable Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNode()
		 * @generated
		 */
		EClass ADAPTABLE_NODE = eINSTANCE.getAdaptableNode();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NODE__NAME = eINSTANCE.getAdaptableNode_Name();

		/**
		 * The meta object literal for the '<em><b>End Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__END_PERFORMANCE = eINSTANCE.getAdaptableNode_EndPerformance();

		/**
		 * The meta object literal for the '<em><b>Intermediate Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE = eINSTANCE.getAdaptableNode_IntermediatePerformance();

		/**
		 * The meta object literal for the '<em><b>Sdn Node Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__SDN_NODE_PERFORMANCE = eINSTANCE.getAdaptableNode_SdnNodePerformance();

		/**
		 * The meta object literal for the '<em><b>Network Interface</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__NETWORK_INTERFACE = eINSTANCE.getAdaptableNode_NetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Adaptation Group</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__ADAPTATION_GROUP = eINSTANCE.getAdaptableNode_AdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl <em>Adaptable Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLink()
		 * @generated
		 */
		EClass ADAPTABLE_LINK = eINSTANCE.getAdaptableLink();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_LINK__NAME = eINSTANCE.getAdaptableLink_Name();

		/**
		 * The meta object literal for the '<em><b>Link Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__LINK_PERFORMANCE = eINSTANCE.getAdaptableLink_LinkPerformance();

		/**
		 * The meta object literal for the '<em><b>Network Interface</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__NETWORK_INTERFACE = eINSTANCE.getAdaptableLink_NetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Adaptation Group</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__ADAPTATION_GROUP = eINSTANCE.getAdaptableLink_AdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl <em>Adaptable Link Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformance()
		 * @generated
		 */
		EClass ADAPTABLE_LINK_PERFORMANCE = eINSTANCE.getAdaptableLinkPerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_LINK_PERFORMANCE__NAME = eINSTANCE.getAdaptableLinkPerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Propagation Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_PERFORMANCE__PROPAGATION_DELAY = eINSTANCE.getAdaptableLinkPerformance_PropagationDelay();

		/**
		 * The meta object literal for the '<em><b>Maximal Supported Bandwidth</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_PERFORMANCE__MAXIMAL_SUPPORTED_BANDWIDTH = eINSTANCE.getAdaptableLinkPerformance_MaximalSupportedBandwidth();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl <em>Adaptable End Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformance()
		 * @generated
		 */
		EClass ADAPTABLE_END_PERFORMANCE = eINSTANCE.getAdaptableEndPerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_END_PERFORMANCE__NAME = eINSTANCE.getAdaptableEndPerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Software Layers Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = eINSTANCE.getAdaptableEndPerformance_SoftwareLayersDelay();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl <em>Adaptable Intermediate Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_INTERMEDIATE_PERFORMANCE = eINSTANCE.getAdaptableIntermediatePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME = eINSTANCE.getAdaptableIntermediatePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Forwarding Latency</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = eINSTANCE.getAdaptableIntermediatePerformance_ForwardingLatency();

		/**
		 * The meta object literal for the '<em><b>Switching Capacity PPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = eINSTANCE.getAdaptableIntermediatePerformance_SwitchingCapacityPPS();

		/**
		 * The meta object literal for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = eINSTANCE.getAdaptableIntermediatePerformance_ForwardingBandwidthBPS();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl <em>Adaptable Sdn Node Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_SDN_NODE_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_SDN_NODE_PERFORMANCE__NAME = eINSTANCE.getAdaptableSdnNodePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Software Switching Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_SDN_NODE_PERFORMANCE__SOFTWARE_SWITCHING_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance();

		/**
		 * The meta object literal for the '<em><b>Hardware Switching Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_SDN_NODE_PERFORMANCE__HARDWARE_SWITCHING_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance_HardwareSwitchingPerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl <em>Adaptable Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterface()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE = eINSTANCE.getAdaptableNetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NETWORK_INTERFACE__NAME = eINSTANCE.getAdaptableNetworkInterface_Name();

		/**
		 * The meta object literal for the '<em><b>Network Interface Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE__NETWORK_INTERFACE_PERFORMANCE = eINSTANCE.getAdaptableNetworkInterface_NetworkInterfacePerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl <em>Adaptable Network Interface Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE = eINSTANCE.getAdaptableNetworkInterfacePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__NAME = eINSTANCE.getAdaptableNetworkInterfacePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__PACKET_PROCESSING_TIME = eINSTANCE.getAdaptableNetworkInterfacePerformance_PacketProcessingTime();

		/**
		 * The meta object literal for the '<em><b>Interface Throughput</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__INTERFACE_THROUGHPUT = eINSTANCE.getAdaptableNetworkInterfacePerformance_InterfaceThroughput();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl <em>Adaptation Groups</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationGroups()
		 * @generated
		 */
		EClass ADAPTATION_GROUPS = eINSTANCE.getAdaptationGroups();

		/**
		 * The meta object literal for the '<em><b>Groups</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_GROUPS__GROUPS = eINSTANCE.getAdaptationGroups_Groups();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptationGroup()
		 * @generated
		 */
		EClass IADAPTATION_GROUP = eINSTANCE.getIAdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl <em>Node Adaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getNodeAdaptationGroup()
		 * @generated
		 */
		EClass NODE_ADAPTATION_GROUP = eINSTANCE.getNodeAdaptationGroup();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE_ADAPTATION_GROUP__ITEMS = eINSTANCE.getNodeAdaptationGroup_Items();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl <em>Link Adaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getLinkAdaptationGroup()
		 * @generated
		 */
		EClass LINK_ADAPTATION_GROUP = eINSTANCE.getLinkAdaptationGroup();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_ADAPTATION_GROUP__ITEMS = eINSTANCE.getLinkAdaptationGroup_Items();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.AlternativeParameterSet <em>Alternative Parameter Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.AlternativeParameterSet
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeParameterSet()
		 * @generated
		 */
		EClass ALTERNATIVE_PARAMETER_SET = eINSTANCE.getAlternativeParameterSet();

		/**
		 * The meta object literal for the '<em><b>Alternative</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ALTERNATIVE_PARAMETER_SET__ALTERNATIVE = eINSTANCE.getAlternativeParameterSet_Alternative();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableImpl <em>Alternative Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariable()
		 * @generated
		 */
		EClass ALTERNATIVE_VARIABLE = eINSTANCE.getAlternativeVariable();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl <em>Alternative Variable Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariableSet()
		 * @generated
		 */
		EClass ALTERNATIVE_VARIABLE_SET = eINSTANCE.getAlternativeVariableSet();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongImpl <em>Alternative Constant Long</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeConstantLong()
		 * @generated
		 */
		EClass ALTERNATIVE_CONSTANT_LONG = eINSTANCE.getAlternativeConstantLong();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongVariableSetImpl <em>Alternative Constant Long Variable Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeConstantLongVariableSetImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeConstantLongVariableSet()
		 * @generated
		 */
		EClass ALTERNATIVE_CONSTANT_LONG_VARIABLE_SET = eINSTANCE.getAlternativeConstantLongVariableSet();

	}

} //DNIAPPackage
