/**
 */
package tools.descartes.dni.dnimm3ap.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.dni.dnimm3ap.AdaptationRepositories;
import tools.descartes.dni.dnimm3ap.DNIAPFactory;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;

/**
 * This is the item provider adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptationRepositories} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationRepositoriesItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptationRepositoriesItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NODE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__LINK_REPOSITORY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns AdaptationRepositories.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/AdaptationRepositories"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_AdaptationRepositories_type");
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(AdaptationRepositories.class)) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NODE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableNodeRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableEndPerformanceRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableIntermediatePerformanceRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableSdnNodePerformanceRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableNetworkInterfaceRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableNetworkInterfacePerformanceRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__LINK_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableLinkRepository()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY,
				 DNIAPFactory.eINSTANCE.createAdaptableLinkPerformanceRepository()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return Dnimm3apEditPlugin.INSTANCE;
	}

}
